#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "m_data.h"
#include "m_sr.h"

/* Save, restore routines */

void SaveMusStatus(struct MusData *Buf)
{
	int p = MusData.Paused;
	SetPause(1);
    FreeUncompressedData();
    memcpy(Buf, &MusData, sizeof(*Buf));
    /* FIXME: Save music device status */
    SetPause(p);
}

void RestoreMusStatus(const struct MusData *Buf)
{
	SetPause(1);
    memcpy(&MusData, Buf, sizeof(*Buf));
    if(MusData.driver)MusData.driver->reset();
    UncompressChannels();
    /* Paused flag was saved as 1 */
    SetPause(0);
}

void FreeUncompressedData(void)
{
	unsigned a;
	for(a=0; a<MAXCHN; ++a)
	{
		if(MusData.PlayData.ch[a].patndata)
			free(MusData.PlayData.ch[a].patndata);
	}
}

void UncompressChannels(void)
{
	unsigned a;
	
	const struct InternalChanData *chans = MusData.SongData.Chans[MusData.PlayData.posi.Pat];
	
	printf("Pattern %u:\n", MusData.PlayData.posi.Pat);
	
	for(a=0; a<MusData.SongData.Hdr->ChanCount; ++a)
	{
		const BYTE *src = (const BYTE *)chans + sizeof(*chans);
		BYTE *dest = (BYTE *)calloc(chans->OriginalByteSize, 1); /* We want zero */
		BYTE bbb, ooo, limit;
		unsigned srcbitpos=0, destbitpos=0;
		
		MusData.PlayData.ch[a].patndata = dest;
		
		bbb = chans->bbbooo >> 4;
		ooo = chans->bbbooo & 15;
		limit = 3 + bbb + ooo;
		
		printf("  a=%u: bbb=%u, ooo=%u\n", a, bbb, ooo);
		
        /* unsigned ReadBits(const BYTE *data, unsigned pos, unsigned num) */
		
		for(; srcbitpos < chans->BitCount; )
		{
			unsigned b = ReadBits(src, srcbitpos, 3);
			if(b == 6)
			{
				WriteBits(dest, destbitpos, 3, 2);
				destbitpos += 2;
				srcbitpos += 3;
				continue;
			}
			if(b == 7)
			{
				WORD bb = ReadBits(src, srcbitpos+3,     bbb);
				WORD oo = ReadBits(src, srcbitpos+3+bbb, ooo);
				printf("     Got bb=%u, oo=%u (destbitpos=%u).\n", bb,oo, destbitpos);
				CopyBits(dest, destbitpos, dest, destbitpos-oo-1, bb+limit+1);

				srcbitpos += limit;
				destbitpos += bb+limit+1;
				continue;
			}
			WriteBits(dest, destbitpos++, ReadBits(src, srcbitpos++, 1), 1);
		}
		
		chans = (const struct InternalChanData *)((const BYTE *)chans + ((chans->BitCount+7) >> 3) + sizeof(*chans));
	}
}
